/// \file main.c VSOS3 Audio Device Driver with input/output (AUDIO.DL3)
/// \author Henrik Herranen, VLSI Solution Oy
// For further instructions on how to use the audio driver can be found
// in the VS1005 VSOS Programmer's Guide, available at
// http://www.vlsi.fi/en/support/software/vside.html

/* For free support for VSIDE, please visit www.vsdsp-forum.com */

// Starting point template for creating VSOS3 libraries and device drivers.
// This will create a <projectname>.DL3 file, which you can copy to 
// your VS1005 Developer Board's system disk's SYS subdirectory.

// DL3 files require VSOS3 kernel version 0.3x to run.


// If you add the libary name to S:CONFIG.TXT, and put the library 
// to S:SYS, it will be loaded and run during boot-up. 

#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <string.h>
#include <mutex.h>
#include <kernel.h>
#include <aucommon.h>
#include <stdlib.h>
#include <speedshift.h>
#include <sysmemory.h>
#include "../ft3To2.h"
#include "../miscAsm.h"

#if 0
u_int16 audioMutex;
#endif
FILE *audio_orig = NULL;
extern SIMPLE_FILE audioFile;

//void (*RomStart)(void) = (void (*)(void)) 0x8000;

u_int16 AudioWrite(register __i0 VO_FILE *self, u_int16 *data,
		   u_int16 sourceIndex, u_int16 bytes);

DLLENTRY(init)
ioresult init(char *parameters) {
  int ch;
  
#if defined(USE_STDAUDIOOUT)
  audio_orig = stdaudioout;
  ch = ioctl(stdaudioout, IOCTL_AUDIO_GET_OCHANNELS, NULL);
  if (ch < 0) ch = 2;
  if (ch != 2) {
    printf("E: stdaudioout not 2 channels\n");
  } else {
    stdaudioout = &audioFile;
    audioFile.Identify = audio_orig->Identify;
    audioFile.op->Ioctl(&audioFile, IOCTL_RESTART, NULL);
  }
#elif defined(USE_STDAUDIOIN)
  audio_orig = stdaudioin;
  ch = ioctl(stdaudioin, IOCTL_AUDIO_GET_ICHANNELS, NULL);
  if (ch != 3) {
    printf("E: stdaudioin not 3 channels\n");
  } else {
    stdaudioin = &audioFile;
    audioFile.Identify = audio_orig->Identify;
    audioFile.op->Ioctl(&audioFile, IOCTL_RESTART, NULL);
  }
#endif

  
  return S_OK;
}


DLLENTRY(fini)
void fini(void) {
  // Add code here to force release of resources such as 
  // memory allocated with malloc, entry points, 
  // hardware locks or interrupt handler vectors.
#if defined(USE_STDAUDIOOUT)
  stdaudioout = audio_orig;
#elif defined(USE_STDAUDIOIN)
  stdaudioin = audio_orig;
#endif
}
